#include "main.h"

void fat_read(int *fat, unsigned char *img)
{
	int i, j = 0;

	for (i = 0; i < 2880; i += 2) {
		fat[i] = (img[j] | img[j + 1] << 8) & 0x0fff;
		fat[i + 1] = (img[j + 1] >> 4 | img[j + 2] << 4) & 0x0fff;
		j += 3;
	}
	return;
}

struct file *file_search(unsigned char *name)
{
	struct file *file = (struct file *) (DISK_ADDR + 0x00002600);
	int i, j;
	unsigned char s[12];

	for (i = 0; i < 11; i++) {
		s[i] = ' ' ;
	}
	i = 0;
	for (j = 0; name[j] != 0; j++) {
		if (i >= 11) {
			return 0;
		}
		if (name[j] == '.' && j <= 8) {
			i = 8;
		} else {
			s[i] = name[j];
			if ('a' <= s[i] && s[i] <= 'z') {
				s[i] -= 0x20;
			}
			i++;
		}
	}
	for (i = 0; i < 224;) {
		if (file->name[0] == 0x00) {
			break;
		}
		if ((file->type & 0x18) == 0) {
			for (j = 0; j < 11; j++) {
				if (file[i].name[j] != s[j]) {
					goto next;
				}
			}
			return file + i;
		}
next:
		i++;
	}
	return 0;
}

unsigned char *file_read(int *fat, int caddr, int *size)
{
	struct memory *mem = (struct memory *) MEMORY_ADDR;
	int size2;
	unsigned char *buf, *buf2;

	buf = (unsigned char *) memory_alloc(mem, *size);
	file_read0(fat, caddr, *size, buf);
	if (*size >= 17) {
		size2 = tek_getsize(buf);
		if (size2 > 0) {	/* tekkĂ */
			buf2 = (unsigned char *) memory_alloc(mem, size2);
			tek_decomp(buf, buf2, size2);
			memory_free(mem, (int) buf, *size);
			buf = buf2;
			*size = size2;
		}
	}
	return buf;
}

void file_read0(int *fat, int caddr, int size, unsigned char *buf)
{
	unsigned char *img = (unsigned char *) (DISK_ADDR + 0x003e00);
	int i;

	for (;;) {
		if (size <= 512) {
			for (i = 0; i < size; i++) {
				buf[i] = img[caddr * 512 + i];
			}
			return;
		}
		for (i = 0; i < 512; i++) {
			buf[i] = img[caddr * 512 + i];
		}
		size -= 512;
		buf += 512;
		caddr = fat[caddr];
	}
}
